function doa=root_music_doaP(r,d,delta,var_fase)
%
% Metodo MUSIC per la stima della direzione di arrivo
%
%      r     <- dati dell'array lineare uniforme
%      d     <- numero delle sorgenti
%      delta <- spaziatura fra i sensori in lunghezza d'onda
%      doa   -> vettore delle stime DOA

[m,N]=size(r);

% calcolo della matrice di covarianza campionata
R=r*r'/N;
Rt=Ftoeplitz(m,R);
B=B_matrix(m,var_fase);

P=B.*Rt;
% decomposizione della matrice di covarianza Rt,svd ordina gli autovalori in
% modo decrescente
[U,D,V]=svd(P);

E=U(:,d+1:m);

C=E*E';   % mxm
% vengono individuati i coefficienti del polinomio nella slide 243 dell'allegato stoica 
for kk=1:2*m-1,
    a(kk,1)=sum(diag(C,kk-m));
end
ra=roots(a);

% vengono trovate le d radici del polinomio che sono pi vicine e
% dentro il cerchio unitario

[dum,ind]=sort(abs(ra));
rb=ra(ind(1:m-1));

% scelta delle d radici pi prossime al cerchio unitario
[dumm,I]=sort(abs(abs(rb)-1));
w=angle(rb(I(1:d)));


% calcolo delle DOA
doa=asin(w/delta/pi/2)*180/pi;



