function doa=root_music_doaSTOICAPKe(r,d,delta,var_fase,v_err)
%
% Metodo MUSIC(Paulraj-Kailath con errore) per la stima della direzione di arrivo
%      v_err <-varianza dell'incremento di fase errata
%      r     <- dati dell'array lineare uniforme
%      d     <- numero delle sorgenti
%      delta <- spaziatura fra i sensori in lunghezza d'onda
%      doa   -> vettore delle stime DOA

[m,N]=size(r);

% calcolo della matrice di covarianza campionata
R=r*r'/N;
Rt=Ftoeplitz(m,R);
B1=B_matrix(m,var_fase);
P=B1.*Rt;
B2=B_matrix(m,v_err);
C=1./B2;

SH=C.*P;

% decomposizione della matrice di covarianza,svd ordina gli autovalori in
% modo decrescente
[U,D,V]=svd(SH);

E=U(:,d+1:m);

C=E*E';   % mxm
% vengono individuati i coefficienti del polinomio nella slide 243 dell'allegato stoica 
for kk=1:2*m-1,
    a(kk,1)=sum(diag(C,kk-m));
end
ra=roots(a);

% vengono trovate le d radici del polinomio che sono pi vicine e
% dentro il cerchio unitario

[dum,ind]=sort(abs(ra));
rb=ra(ind(1:m-1));

% scelta delle d radici pi prossime al cerchio unitario
[dumm,I]=sort(abs(abs(rb)-1));
w=angle(rb(I(1:d)));


% calcolo delle DOA
doa=asin(w/delta/pi/2)*180/pi;



