function [PSSP,x,D,D1,matriceDiff]=music_doaFEDE1(signal,M,d,f_centrale)
%
% Metodo MUSIC per la stima della direzione di arrivo
% lavora su R
%
%      signal      <- dati dell'array lineare uniforme
%      d           <- numero delle sorgenti
%      f_centrale  <- a cui lavora l'array    
%      plot PSSP   -> vettore delle stime DOA

[m,N]=size(signal);
  
R=signal*signal'/N;

% E' possibile rendere la matrice R toeplitz
% nel modo che segue: Rt=Ftoeplitz(m,R);

passo=0.2;
c=3e8;

naz=round(180/passo);
delta=spaziatura(f_centrale);

% D= matrice diagonale contenente gli autovalori ordinati in 
%    senso decrescente.
[U,D,V]=svd(R);

for ia=1:naz

Az=(ia-1-naz/2)*passo;

psi=[0:m-1]*2*pi*f_centrale*(delta/c)*sin(pi*Az/180);

% vettore colonna della matrice di Vandermonde per un theta generico
a_theta=exp(-j*psi');

% calcolo della potenza del pseudo-spettro

sum=0;

for k=d+1:m

sum=sum+abs(a_theta'*U(:,k))^2;

end
pssp(ia)=1/sum;
end

figure(1);

PSSP=10*log10(pssp);
x=([1:naz]-1-naz/2)*passo;

plot(x,PSSP);

title('metodo MUSIC');

xlabel('angoli di incidenza in gradi')

ylabel('pseudospettro MUSIC (dB)')


