function [D1,PSSP]=TRmusicfreq(m,d,X,tau,Pn,val_x_ini,f_centrale,zmin)
% pseudospettro calcolato considerando segnali Narrow Band in un
% canale selettivo in frequenza
% X  una matrice di d righe(d=numero delle sorgenti)
% m=numero elementi dell'array 

% matrice delle coordinate degli elementi dell'array
Rmatr = creaRmatrUWB(m,f_centrale,val_x_ini);% m x 2

Gmatrix = zeros(m,d);

c=3e8;
 
lambda=c/f_centrale;

gd = zeros(m,1);

for j=1:d

    for i=1:m

        % vettore colonna delle funzioni di Green
        gd(i,1) = creaGreenlambda(f_centrale,Rmatr(i,:),X(j,:),val_x_ini);   
    
    end
    
    % introduco un'attenuazione di 10 dB (canale selettivo in frequenza) 
    %Gmatrix(:,j) = gd/10;
    Gmatrix(:,j)=gd; % in assenza di disturbi freqenziali.
end
reflectCoeffs=eye(d);
for(k=1:d)
    reflectCoeffs(k,k)=tau(k);
end
K=Gmatrix*reflectCoeffs*conj(Gmatrix');% mxm

rumore=sqrt(Pn/2)*(randn(m,m)+i*randn(m,m));

H=K+rumore;

[U1,D1,V1]=svd(H);

passo=(c/f_centrale)/4;

for k=1:100

    x=k*passo;
    
    for n=1:100
    
    z=n*passo+zmin;
    
        for l=1:m

        gp(l,1) = creaGreenlambda(f_centrale,Rmatr(l,:),[x z],val_x_ini);   
    
        end

% calcolo della potenza del pseudo-spettro

        sum=0;

        for f=d+1:m

        sum=sum+abs(gp'*U1(:,f))^2;

        end
        
        pssp(k,n)=1/sum;
    
    end
    
end

PSSP=10*log10(pssp);

[asseX,asseZ]= meshgrid([1:100]*passo,[1:100]*passo);

meshc(asseX,asseZ,PSSP);


